;---------------------------------------------
;cutman
;---------------------------------------------
;!hasami_flag,xが hasami_flag,x is
;0のときは開いている Open when 0
;1のときは閉じている Closed when 1.
;2のときは描画しない No drawing when 2
;---------------------------------------------
!jump_power = $02
!fire_power = $02
!cape_power = $02
!item_power = $0F
;---------------------------------------------
; do not change it
;---------------------------------------------
!pose = !1504
!state = !1510
!hasami_flag = !151C
!timer = !1540
!anime_count = !1602
!muteki = !1558
!return = !1594
WalkingXSpeed:
    db $14,$EC
;---------------------------------------------
; sprite
;---------------------------------------------
print "INIT ",pc
	LDA #$08
	STA !pose,x
	RTL

print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR +
	PLB
	RTL
+
	LDA #$00
	%SubOffScreen()
	JSR gfx
	
	LDA $9D
	BNE return
	LDA !sprite_status,x
	CMP #$08
	BNE return

	LDA !state,x
	JSL $0086DF|!BankB
	dw wait,posing,hpup,walking1
wait:
	%SubHorzPos()
	TYA
	STA !157C,x
	LDA !sprite_x_high,x
	CMP $95
	BNE +
	LDA $77
	AND #$04
	BEQ +
	LDA #$0B
	STA $71
	JSL $01802A|!BankB
	LDA !sprite_blocked_status,x
	AND #$04
	BEQ +
	STZ !pose,x
	INC !state,x
	LDA #$10
	STA !timer,x
+
return:
	RTS
posing:
	LDA !timer,x
	BNE +
	LDA !anime_count,x
	CMP #$07
	BCS ++
	AND #$01
	STA !pose,x
	STA !hasami_flag,x
	LDA #$08
	STA !timer,x
	INC !anime_count,x
+
	RTS
++
	STZ $00
	LDA #$C0
	STA $01
	STZ $02
	STZ $03
	LDA !new_sprite_num,x
	DEC A
	SEC
	%SpawnSprite()
	INC !state,x
	LDA #$10
	STA !timer,x
	RTS
hpup:
	LDA !timer,x
	BNE +
	LDA !C2,x
	INC A
	STA !C2,x
	LDA !C2,x
	CMP #$1C
	BCS ++
	LDA #$01
	STA $1DFC|!Base2
	LDA #$02
	STA !timer,x
+
	RTS
++
	INC !state,x
	LDA #$10
	STA !timer,x
	STZ $71
-
	RTS
walking1:
	JSL $01802A|!BankB
	JSR check_mario
	LDA.w !sprite_blocked_status,x
	AND.b #$04
	BEQ.b ++
	%SubHorzPos()
	LDA.w !sprite_blocked_status,x
	AND.b #$03
	BEQ.b +
	LDA.b #$C0
	STA.b !sprite_speed_y,x
	LDA.b !1602
	BRA.b ++

+:
	LDA.w WalkingXSpeed,y
	STA.b !sprite_speed_x,x
	REP.b #$20
	LDA.b $0E
	BPL.b +
	EOR.w #$FFFF
	INC
+:
	CMP.w #$0030
	SEP.b #$20
	BCS.b +
	LDA.b #$80
	STA.b !sprite_speed_y,x
	LDA !1602
+:
	INC !1570,x
	LDA !1570,x
	AND #$07	; Speed of animation, should be $01, $03, $07 or $0F
	BNE +
	LDA !pose,x
	INC
	CMP #$08
	BNE +
	LDA #$02
+:
	STA.w !pose,x
++:
	RTS


check_mario:
	LDA !muteki,x
	BEQ +
	RTS
+
	%CapeContact()
	BCC +
	LDA #!cape_power
	STA $00
	JMP mario_win
+
	%FireballContact()
	BCC +
	LDA #!fire_power
	STA $00
	JMP mario_win
+
	JSL $03B69F|!BankB
	LDY #!SprSize
-
	LDA !sprite_status,y
	CMP #$09
	BCC +
	PHX
	TYX
	JSL $03B6E5|!BankB
	PLX
	JSL $03B72B|!BankB
	BCC +
	LDA #$02
	STA !sprite_status,y
	LDA #$00
	STA !sprite_speed_x,y
	STA !sprite_speed_y,y
	LDA #!item_power
	STA $00
	JMP mario_win
+
	DEY
	BPL -
	
	JSL $01A7DC|!BankB
	BCC +
	LDA #!jump_power
	STA $00
	%SubVertPos()
	LDA $0F
	CMP #$F0
	BPL boss_win
	LDA $7D
	BPL ++
boss_win:
	JSL $00F5B7|!BankB
+
	RTS
++
	JSL $01AA33|!BankB
	JSL $01AB99|!BankB
mario_win:
	LDA #$20
	STA !muteki,x
	LDA #$28
	STA $1DFC|!Base2
	LDA !C2,x
	SEC
	SBC $00
	STA !C2,x
	DEC
	BPL +
tiwn:
	LDA #$1F
	STA $1DF9|!Base2
	LDA #$02
	STA !sprite_status,x
	STZ !sprite_speed_x,x
	STZ !sprite_speed_y,x
	RTS

	LDA !extra_bits,x
	AND #$04
	BNE extra_bit_set
; extra bit clear

extra_bit_set:
;extra bit set
	LDA #$00	; Exit type
	STA $141C|!addr	;
	LDA #$0B	; Music (needs to be changed if using AMK)
	STA $1DFB|!addr	;
	LDA #$FF	;
	STA $0DDA|!addr	; Music thing
	STA $1493|!addr	; Level-end timer
	STZ $1490|!addr	; Disable star timer
	LDA #$FF	; Boss goal sequence (prevents auto-walk)
	STA $13C6|!addr	;
+
	LDA #$28
	STA $1DFC|!Base2
	RTS

x_pos:
	db $F8,$08,$F8,$08,$01
	db $F8,$08,$F8,$08,$01
	db $F8,$08,$F8,$08,$FD
	db $F8,$08,$F8,$08,$FD
	db $F8,$08,$F8,$08,$FD
	db $F8,$08,$F8,$08,$FD
	db $F8,$08,$F8,$08,$FD
	db $F8,$08,$F8,$08,$FD
	db $F8,$08,$F8,$08,$00
	db $F8,$08,$F8,$08,$01
	db $F5,$05,$F5,$05,$FE
	db $FC,$FC,$04,$04
tilemap:
	db $00,$02,$20,$22,$55
	db $04,$06,$24,$26,$55
	db $08,$0A,$28,$2A,$55
	db $0C,$0E,$2C,$2E,$55
	db $40,$42,$60,$62,$55
	db $44,$46,$64,$66,$55
	db $48,$4A,$68,$6A,$55
	db $4C,$4E,$6C,$6E,$55
	db $80,$82,$84,$86,$55
	db $88,$8A,$8C,$8E,$55
	db $CC,$CE,$EC,$EE,$55
	db $D6,$E6,$D7,$E7
y_pos:
	db $F0,$F0,$00,$00,$E7
	db $F0,$F0,$00,$00,$E7
	db $F0,$F0,$00,$00,$E9
	db $F0,$F0,$00,$00,$E6
	db $F0,$F0,$00,$00,$E7
	db $F0,$F0,$00,$00,$E9
	db $F0,$F0,$00,$00,$E6
	db $F0,$F0,$00,$00,$E7
	db $F0,$F0,$00,$00,$E8
	db $F0,$F0,$00,$00,$E7
	db $F0,$F0,$00,$00,$E7
	db $F8,$00,$F8,$00
hasami_tile:
	db $A0,$C0
tile_addr:
	db $00,$05,$0A,$0F
	db $14,$19,$1E,$23
	db $28,$2D,$32,$37
gfx:
	%GetDrawInfo()
	LDA !157C,x
	EOR #$01
	ASL #6
	STA $02
	
	LDA !15F6,x
	STA $04
	

	PHX
	LDA !hasami_flag,x
	CMP #$02
	BCC +
	LDA #$03
	STA $05
	BRA ++
+
	TAX
	LDA hasami_tile,x
	STA $03
	LDA #$04
	STA $05
++
	PLX
	PHX
	LDA !muteki,x
	BEQ +
	LDA $14
	AND #$01
	BEQ +
	LDA #$03
	STA $05
	LDA #$0B
	BRA ++
+
	LDA !pose,x
++
	TAX
	LDA tile_addr,x
	STA $06
	LDX $05
-
	PHX
	TXA
	CLC
	ADC $06
	TAX
	
	LDA x_pos,x
	PHX
	LDX $02
	BEQ +
	EOR #$FF
	INC A
+
	PLX
	CLC
	ADC $00
	STA $0300|!Base2,y
	LDA tilemap,x
	CMP #$55
	BNE +
	LDA $03
+
	STA $0302|!Base2,y
	
	LDA y_pos,x
	CLC
	ADC $01
	STA $0301|!Base2,y
	
	LDA $04
	ORA $02
	ORA $64
	STA $0303|!Base2,y
	
	PLX
	INY #4
	DEX
	BPL -
	
	PLX
	LDY #$02
	LDA $05
	%FinishOAMWrite()
	RTS